
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_assignmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_assignments = await db.job_assignments.create(
            {
                id: data.id || undefined,
        
        assignment_role: data.assignment_role
        ||
        null
            ,
            
        assigned_at: data.assigned_at
        ||
        null
            ,
            
        is_confirmed: data.is_confirmed
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_assignments.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await job_assignments.setJob( data.job || null, {
            transaction,
        });
        
        await job_assignments.setAssignee( data.assignee || null, {
            transaction,
        });
        
        await job_assignments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return job_assignments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_assignmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                assignment_role: item.assignment_role
            ||
            null
            ,
            
                assigned_at: item.assigned_at
            ||
            null
            ,
            
                is_confirmed: item.is_confirmed
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_assignments = await db.job_assignments.bulkCreate(job_assignmentsData, { transaction });

        // For each item created, replace relation files
        

        return job_assignments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const job_assignments = await db.job_assignments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.assignment_role !== undefined) updatePayload.assignment_role = data.assignment_role;
        
        
        if (data.assigned_at !== undefined) updatePayload.assigned_at = data.assigned_at;
        
        
        if (data.is_confirmed !== undefined) updatePayload.is_confirmed = data.is_confirmed;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_assignments.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await job_assignments.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.job !== undefined) {
            await job_assignments.setJob(
              
              data.job,
              
              { transaction }
            );
        }
        
        if (data.assignee !== undefined) {
            await job_assignments.setAssignee(
              
              data.assignee,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await job_assignments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return job_assignments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_assignments = await db.job_assignments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_assignments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_assignments) {
                await record.destroy({transaction});
            }
        });


        return job_assignments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_assignments = await db.job_assignments.findByPk(id, options);

        await job_assignments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_assignments.destroy({
            transaction
        });

        return job_assignments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_assignments = await db.job_assignments.findOne(
            { where },
            { transaction },
        );

        if (!job_assignments) {
            return job_assignments;
        }

        const output = job_assignments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await job_assignments.getWorkspace({
            transaction
        });
        
        
        output.job = await job_assignments.getJob({
            transaction
        });
        
        
        output.assignee = await job_assignments.getAssignee({
            transaction
        });
        
        
        output.organizations = await job_assignments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.jobs,
        as: 'job',
        
        where: filter.job ? {
          [Op.or]: [
            { id: { [Op.in]: filter.job.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.job.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'assignee',
        
        where: filter.assignee ? {
          [Op.or]: [
            { id: { [Op.in]: filter.assignee.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.assignee.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.assigned_atRange) {
                const [start, end] = filter.assigned_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    assigned_at: {
                    ...where.assigned_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    assigned_at: {
                    ...where.assigned_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.assignment_role) {
                where = {
                    ...where,
                assignment_role: filter.assignment_role,
            };
            }
            
            if (filter.is_confirmed) {
                where = {
                    ...where,
                is_confirmed: filter.is_confirmed,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_assignments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_assignments',
                        'assignment_role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_assignments.findAll({
            attributes: [ 'id', 'assignment_role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['assignment_role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.assignment_role,
        }));
    }

    
};

